regina::GluingPermSearcher< 4 > Class Template Reference
Census of Triangulations

A utility class for searching through all possible gluing permutation sets that correspond to a given pentachoron facet pairing. More...

`#include <census/gluingpermsearcher4.h>`

Inheritance diagram for regina::GluingPermSearcher< 4 >:

## Classes

struct | PentEdgeState
| A structure used to track equivalence classes of pentachoron edges as the gluing permutation set is constructed. More...
struct | PentTriangleState
| A structure used to track equivalence classes of pentachoron triangles as the gluing permutation set is constructed. More...

## Public Types

typedef void(* | Use) (const GluingPermSearcher< 4 > *, void *)
| A routine that can do arbitrary processing upon a set of gluing permutations. More...

## Public Member Functions

| GluingPermSearcher (const FacetPairing< 4 > *pairing, const FacetPairing< 4 >::IsoList *autos, bool orientableOnly, bool finiteOnly, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Initialises a new search for gluing permutation sets. More...
| GluingPermSearcher (std::istream &in, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Initialises a new search manager based on data read from the given input stream. More...
virtual | ~GluingPermSearcher ()
| Destroys this search manager and all supporting data structures. More...
virtual void | runSearch (long maxDepth=-1)
| Generates all possible gluing permutation sets that satisfy the current search criteria. More...
bool | completePermSet () const
| Determines whether this search manager holds a complete gluing permutation set or just a partially completed search state. More...
void | dumpTaggedData (std::ostream &out) const
| Dumps all internal data in a plain text format, along with a marker to signify which precise class the data belongs to. More...
virtual void | dumpData (std::ostream &out) const
| Dumps all internal data in a plain text format to the given output stream. More...
bool | inputError () const
| Was an error found during construction from an input stream? More...
unsigned | size () const
| Returns the total number of simplices under consideration. More...
const FacetPairing< dim > * | facetPairing () const
| Returns the specific pairing of simplex facets that this set of gluing permutations complements. More...
Perm< dim+1 > | gluingPerm (const FacetSpec< dim > &source) const
| Returns the gluing permutation associated with the given simplex facet. More...
Perm< dim+1 > | gluingPerm (unsigned simp, unsigned facet) const
| Returns the gluing permutation associated with the given simplex facet. More...
Triangulation< dim > * | triangulate () const
| Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing. More...

## Static Public Member Functions

static void | findAllPerms (const FacetPairing< 4 > *pairing, const FacetPairing< 4 >::IsoList *autos, bool orientableOnly, bool finiteOnly, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| The main entry routine for running a search for all gluing permutation sets that complement a given pentachoron facet pairing. More...
static GluingPermSearcher< 4 > * | bestSearcher (const FacetPairing< 4 > *pairing, const FacetPairing< 4 >::IsoList *autos, bool orientableOnly, bool finiteOnly, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Constructs a search manager of the best possible class for the given search parameters. More...
static GluingPermSearcher< 4 > * | readTaggedData (std::istream &in, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Creates a new search manager based on tagged data read from the given input stream. More...

## Static Public Attributes

static const char | dataTag_
| A character used to identify this class when reading and writing tagged data in text format. More...

## Protected Member Functions

bool | isCanonical () const
| Compares the current set of gluing permutations with its preimage under each automorphism of the underlying facet pairing, in order to see whether the current set is in canonical form (i.e., is lexicographically smallest). More...
bool | badTriangleLink (const FacetSpec< 4 > &facet) const
| Determines whether the permutations already constructed model a 4-manifold triangulation with a (2-dimensional) triangle identified with itself using a non-trivial rotation or reflection. More...
virtual char | dataTag () const
| Returns the character used to identify this class when storing tagged data in text format. More...
int | findTriangleClass (int triID) const
| Returns the representative of the equivalence class containing the given pentachoron triangle. More...
int | findTriangleClass (int triID, Perm< 3 > &twist) const
| Returns the representative of the equivalence class containing the given pentachoron triangle. More...
bool | mergeEdgeClasses ()
| Merges the classes of pentachoron edges as required by the new gluing made at stage orderElt of the search. More...
bool | mergeTriangleClasses ()
| Merges the classes of pentachoron triangles as required by the new gluing made at stage orderElt of the search. More...
void | splitEdgeClasses ()
| Splits the classes of pentachoron edges to mirror the undoing of the gluing at stage orderElt of the search. More...
void | splitTriangleClasses ()
| Splits the classes of pentachoron triangles to mirror the undoing of the gluing at stage orderElt of the search. More...
void | edgeBdryJoin (int edgeID, char end, int adjEdgeID, char twist)
| Signifies that the boundary edges supplied by the linking triangles for the two given pentachoron edges should be marked as adjacent. More...
void | edgeBdryFixAdj (int edgeID)
| Adjusts the bdryNext and bdryTwist arrays for nearby pentachoron edges, to ensure that these arrays are consistent with the bdryNext and bdryTwist arrays stored with the given pentachoron edge. More...
void | edgeBdryBackup (int edgeID)
| Copies the bdryNext and bdryTwist arrays to the bdryNextOld and bdryTwistOld arrays for the given pentachoron edge. More...
void | edgeBdryRestore (int edgeID)
| Copies the bdryNextOld and bdryTwistOld arrays to the bdryNext and bdryTwist arrays for the given pentachoron edge. More...
void | edgeBdryNext (int edgeID, int pent, int edge, int bdryFacet, int next[2], char twist[2])
| Assuming the given edge of the linking triangle for the given pentachoron edge lies on the boundary of the link, this routine identifies the adjacent boundary edges of the link in each direction. More...
bool | edgeBdryLength1 (int edgeID)
| Determines whether one of the edges of the linking triangle for the given pentachoron edge in fact forms an entire one-edge boundary component of the overall 4-manifold edge link. More...
bool | edgeBdryLength2 (int edgeID1, int edgeID2)
| Determines whether edges of the linking triangles for each of the given pentachoron edges combine to form an entire two-edge boundary component of the overall 4-manifold edge link, with one edge from each triangle. More...
void | edgeBdryConsistencyCheck ()
| Runs a number of tests on all pentachoron edges to locate consistency errors in the bdryEdges, bdryNext and bdryTwist members of the PentEdgeState class. More...
void | edgeBdryDump (std::ostream &out)
| Dumps a summary of bdryNext, bdryTwist and bdryEdges for every edge of every pentachoron to the given output stream. More...
int & | permIndex (const FacetSpec< dim > &source)
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
int & | permIndex (unsigned simp, unsigned facet)
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (const FacetSpec< dim > &source) const
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (unsigned simp, unsigned facet) const
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
int | gluingToIndex (const FacetSpec< dim > &source, const Perm< dim+1 > &gluing) const
| Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
int | gluingToIndex (unsigned simp, unsigned facet, const Perm< dim+1 > &gluing) const
| Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
Perm< dim+1 > | indexToGluing (const FacetSpec< dim > &source, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1. More...
Perm< dim+1 > | indexToGluing (unsigned simp, unsigned facet, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1. More...

## Protected Attributes

const FacetPairing< 4 >::IsoList * | autos_
| The set of isomorphisms that define equivalence of gluing permutation sets. More...
bool | autosNew_
| Did we create the isomorphism list autos_ ourselves (in which case we must destroy it also)? More...
bool | orientableOnly_
| Are we only searching for gluing permutations that correspond to orientable triangulations? More...
bool | finiteOnly_
| Are we only searching for gluing permutations that correspond to finite (non-ideal) triangulations? More...
GluingPermSearcher< 4 >::Use | use_
| A routine to call each time a gluing permutation set is found during the search. More...
void * | useArgs_
| Additional user-supplied data to be passed as the second argument to the use_ routine. More...
bool | started_
| Has the search started yet? This helps distinguish between a new search and the resumption of a partially completed search. More...
int * | orientation_
| Keeps track of the orientation of each pentachoron in the underlying triangulation. More...
FacetSpec< 4 > * | order_
| Describes the order in which gluing permutations are assigned to pentachoron facets. More...
int | orderSize_
| The total number of edges in the facet pairing graph, i.e., the number of elements of interest in the order_[] array. More...
int | orderElt_
| Marks which element of order_[] we are currently examining at this stage of the search. More...
unsigned | nEdgeClasses_
| The number of equivalence classes of identified pentachoron edges. More...
PentEdgeState * | edgeState_
| Used for tracking equivalence classes of identified pentachoron edges. More...
int * | edgeStateChanged_
| Tracks the way in which the edgeState_[] array has been updated over time. More...
unsigned | nTriangleClasses_
| The number of equivalence classes of identified pentachoron triangles. More...
PentTriangleState * | triState_
| Used for tracking equivalence classes of identified pentachoron triangles. More...
int * | triStateChanged_
| Tracks the way in which the triState_[] array has been updated over time. More...
const FacetPairing< dim > * | pairing_
| The facet pairing that this permutation set complements. More...
int * | permIndices_
| The index into array Perm<dim+1>::Sn_1 describing how each simplex facet is glued to its partner. More...
bool | inputError_
| Has an error occurred during construction from an input stream? More...

## Static Protected Attributes

static const int | edgeLinkNextFacet [10][5]
| Maintains an ordering of the three pentachoron facets surrounding an edge in a pentachoron. More...
static const int | edgeLinkPrevFacet [10][5]
| Provides backwards links for the ordering described by edgeLinkNextFacet. More...

## Detailed Description

### template<>
class regina::GluingPermSearcher< 4 >

A utility class for searching through all possible gluing permutation sets that correspond to a given pentachoron facet pairing.

Subclasses of GluingPermSearcher<4> correspond to specialised (and heavily optimised) search algorithms that may be used in sufficiently constrained scenarios. The main class GluingPermSearcher<4> offers a default (but slower) search algorithm that may be used in more general contexts.

The simplest way of performing a search through all possible gluing permutations is by calling the static method findAllPerms(). This will examine the search parameters and ensure that the best possible algorithm is used. For finer control over the program flow, the static method bestSearcher() can be used to create a search manager of the most suitable class and then runSearch() can be called on this object directly. For absolute control, a specific algorithm can be forced by explicitly constructing an object of the corresponding class (and again calling runSearch() on that object directly).

The search algorithm used by this base class employs modified union-find structures for both triangle and edge equivalence classes to prune searches that are guaranteed to lead to invalid triangles or edges. This is a 4-dimensional analogue to the algorithms described in "Enumeration of non-orientable 3-manifolds using face-pairing graphs and union-find", Benjamin A. Burton, Discrete Comput. Geom. 38 (2007), no. 3, 527–571.

Note that this class derives from GluingPerms<4>. The search will involve building and repeatedly modifying the inherited GluingPerms<4> data in-place.

Python:\n Not present.

## Member Function Documentation

## facetPairing()

const FacetPairing< dim > * regina::GluingPerms< dim >::facetPairing | ( |  | ) | const

inline inherited

Returns the specific pairing of simplex facets that this set of gluing permutations complements.

Returns
  the corresponding simplex facet pairing.

## gluingPerm() [1/2]

Perm< dim+1 > regina::GluingPerms< dim >::gluingPerm | ( | const FacetSpec< dim > & | source | ) | const

inline inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine facetPairing()).
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  the associated gluing permutation.

## gluingPerm() [2/2]

Perm< dim+1 > regina::GluingPerms< dim >::gluingPerm | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inline inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine facetPairing()).

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  the associated gluing permutation.

## gluingToIndex() [1/2]

int regina::GluingPerms< dim >::gluingToIndex | ( | const FacetSpec< dim > & | source,
|  | const Perm< dim+1 > & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm<dim+1>::Sn_1 that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  source | the simplex facet under investigation.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm<dim+1>::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

## gluingToIndex() [2/2]

int regina::GluingPerms< dim >::gluingToIndex | ( | unsigned | simp,
|  | unsigned | facet,
|  | const Perm< dim+1 > & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm<dim+1>::Sn_1 that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm<dim+1>::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

## indexToGluing() [1/2]

Perm< dim+1 > regina::GluingPerms< dim >::indexToGluing | ( | const FacetSpec< dim > & | source,
|  | int | index
| ) |  | const

inline protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1.

This index into Perm<dim+1>::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  source | the simplex facet under investigation.
  index | an index into Perm<dim+1>::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm<dim+1>::Sn_1.

## indexToGluing() [2/2]

Perm< dim+1 > regina::GluingPerms< dim >::indexToGluing | ( | unsigned | simp,
|  | unsigned | facet,
|  | int | index
| ) |  | const

inline protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1.

This index into Perm<dim+1>::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  index | an index into Perm<dim+1>::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm<dim+1>::Sn_1.

## inputError()

bool regina::GluingPerms< dim >::inputError | ( |  | ) | const

inline inherited

Was an error found during construction from an input stream?

This routine returns `true` if an input stream constructor was used to create this object but the data in the input stream was invalid or incorrectly formatted.

If a different constructor was called (i.e., no input stream was used), then this routine will always return `false`.

Returns
  `true` if an error occurred during construction from an input stream, or `false` otherwise.

## permIndex() [1/4]

int & regina::GluingPerms< dim >::permIndex | ( | const FacetSpec< dim > & | source | ) |

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

## permIndex() [2/4]

const int & regina::GluingPerms< dim >::permIndex | ( | const FacetSpec< dim > & | source | ) | const

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

## permIndex() [3/4]

int & regina::GluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  |

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

## permIndex() [4/4]

const int & regina::GluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

## size()

unsigned regina::GluingPerms< dim >::size | ( |  | ) | const

inline inherited

Returns the total number of simplices under consideration.

Returns
  the number of simplices under consideration.

## triangulate()

Triangulation<dim>* regina::GluingPerms< dim >::triangulate | ( |  | ) | const

inherited

Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing.

Each matched pair of facets and their associated permutations will be realised as two simplex facets in the triangulation glued together with the corresponding gluing permutation. Each unmatched facet will be realised as a boundary facet in the triangulation.

It is the responsibility of the caller of this routine to delete this triangulation once it is no longer required.

Returns
  a newly created triangulation modelled by this structure.

## Member Data Documentation

## inputError_

bool regina::GluingPerms< dim >::inputError_

protected inherited

Has an error occurred during construction from an input stream?

## pairing_

const FacetPairing<dim>* regina::GluingPerms< dim >::pairing_

protected inherited

The facet pairing that this permutation set complements.

This is guaranteed to be the minimal representative of its facet pairing isomorphism class.

## permIndices_

int* regina::GluingPerms< dim >::permIndices_

protected inherited

The index into array Perm<dim+1>::Sn_1 describing how each simplex facet is glued to its partner.

Note that this is not a gluing permutation as such but rather a permutation of 0,...,dim-1 only (see the routines gluingToIndex() and indexToGluing() for conversions). If a permutation has not yet been selected (e.g., if this permutation set is still under construction) then this index is -1.

The documentation for this class was generated from the following file:

- census/gluingpermsearcher4.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).